
;	flamme2 (2nd release)
;	pacHa '05
;
;
;	interactive small fire effect (reloaded %))

;	website - http://aawm.free.fr
;	TiFT prod - http://tift.paxl.org

#include "sng10.inc"



 .ORG START_ADDR
 
start
 
 .db "flamme 2",0
 
debut
	ld	a,r
	ld	(GET_RAND+1),a
 
	ROM_CALL(CLEARLCD)
             
loop:     

; Bottom
	ld	hl,GRAPH_MEM + (62*12) +11
	ld	bc,8*12
	ld	de,GRAPH_MEM + (63*12) +11
	lddr
	
; Newline
      CALL  GET_RAND
      and   %00000111
      jr    nz,notleft
      ld    a,(newline+3-3)
      add   a,a
      inc   a
      ld    (newline+3-3),a
      ld    a,(newline+8-3)
      srl   a
      or    %10000000
      ld    (newline+8-3),a
      jr    DrawLine
notleft
      cp    1
      jr    nz,DrawLine
      ld    a,(newline+3-3)
      srl   a
      ld    (newline+3-3),a
      ld    a,(newline+8-3)
      add   a,a
      ld    (newline+8-3),a
      

DrawLine
      ld    hl,newline
      ld    de,GRAPH_MEM + (63*12) - (8*12) + 3
      ld    bc,12 - 6
      ldir
      
      
	call	Shrink
	call	ShrinkB
	call	ShrinkB2
	call	Scroll
       
      call  CR_GRBCopy
      
      ld    a,$fd       ; [CLEAR]
      out   (1),a
      in    a,(1)
      bit   6,a
      ret   z
      
      ld	hl,_FlameSize
      ld    a,$fe       ; keys
      out   (1),a
      in    a,(1)
      ld    b,a
      bit   3,b
      call  z,_up
      bit   0,b
      call  z,_down
	jr	loop

      
      
_up
	inc	(hl)
	inc	(hl)
_down
	dec	(hl)
	ret
      
      
      
      
          
      
newline
      .db   %00111111,%11111111,%11110000,%00001111,%11111111,%11111100
      
Scroll
      ld    hl,GRAPH_MEM + 12  ; scroll up
      ld    de,GRAPH_MEM
      ld    bc,768-12-(8*12)
      ldir
      ret
   
ShrinkB
	ld    hl,GRAPH_MEM + (63*12) - (6*12)
	jr	_ShrinkB
ShrinkB2
	ld    hl,GRAPH_MEM + (63*12) - (2*12)
_ShrinkB
      CALL  GET_RAND
      ;and   %00000011
      cp    50
      jr    c,NextLineB

      call	Decale
      
CheckLineB
      push  hl
      ld    de,GRAPH_MEM+ (64*12) +12
      call  CP_HL_DE
      pop   hl
      ret	z
      
      jr    _ShrinkB
      
NextLineB
      ld    de,12
      add   hl,de
      jr    CheckLineB
      
	
  
Shrink
      ld    hl,GRAPH_MEM
      
_Shrink
      CALL  GET_RAND
      ;and   %00000011
_FlameSize = $+1
      cp    170
      jr    c,NextLine
      
      ;ccf
	call	Decale
            
CheckLine
      push  hl
      ld    de,GRAPH_MEM+ (63*12) - (8*12)
      call  CP_HL_DE
      pop   hl
      ret	z
      
      jr    _Shrink
      
NextLine
      ld    de,12
      add   hl,de
      jr    CheckLine
      
Decale
      sra    (hl)
      inc   hl
      rr    (hl)
      inc   hl
      rr    (hl)
      inc   hl
      rr    (hl)
      inc   hl
      rr    (hl)
      inc   hl
      rr    (hl)

      ld    de,6
      add   hl,de
      
      sla    (hl)
      dec   hl
      rl    (hl)
      dec   hl
      rl    (hl)
      dec   hl
      rl    (hl)
      dec   hl
      rl    (hl)
      dec   hl
      rl    (hl)
      
      ld    de,6
      add   hl,de
      ret
      
      
GET_RAND         ; from ACE
_rand = $+1
      ld    a,$A6
      push  hl
__rand = $+1
      ld    hl,$8243
      inc   l
      dec   h
      add   a,(hl)
      ld    (__rand),hl
      rlca
      rlca
      sub   h
      add   a,l
      pop   hl
      ld    (_rand),a
      ret

fin

.echo "\nTaille du prog : "
.echo fin-debut+1
.echo "\n\n"